<?php

/**
 * Sample plugin to try out some hooks.
 * This performs an automatic login if accessed from localhost
 *
 * @license GNU GPLv3+
 * @author Thomas Bruederli
 */
class autologon_confixx extends rcube_plugin
{
  private $app;
  public $task = 'login';

  function init()
  {
    $this->app = rcmail::get_instance();
    $this->add_hook('startup', array($this, 'startup'));
    $this->add_hook('authenticate', array($this, 'authenticate'));
  }

  function startup($args)
  {
    $rcmail = rcmail::get_instance();

    // change action to login
    if( empty($_SESSION['user_id']) && !empty($_GET['_autologin']) )
      $args['action'] = 'login';

    return $args;
  }

  function authenticate($args)
  {
    if( empty($_GET['_autologin']) )
      return $args;

    $dbh = $this->app->get_dbh();
    $sql_result = $dbh->query("SELECT * FROM confixx.sessions WHERE id = '{$_COOKIE['SID']}'");
    if( $dbh->num_rows() != 1 )
      return $args;

    $sql_arr = $dbh->fetch_assoc($sql_result);

    $real_session_data = $_SESSION;
    $sdata = session_decode( $sql_arr['sdata'] );
    $confixx_session_data = $_SESSION;
    $_SESSION = $real_session_data;

    $users = $confixx_session_data['_users'][$confixx_session_data['_server_id']];
    if( count($users) != 1 )
      return $args;

    $usernames = array_keys($users);
    $username = $usernames[0];
    $password = $users[$username]['password'];

    $args['user'] = $username;
    $args['pass'] = $password;
    $args['host'] = 'localhost';
    $args['cookiecheck'] = false;
    $args['valid'] = true;

    // delete confixx session. otherwise we will have re-login problems
    $sql_result = $dbh->query("DELETE FROM confixx.sessions WHERE id = '{$_COOKIE['SID']}'");

    return $args;
  }

  function is_localhost()
  {
    return $_SERVER['REMOTE_ADDR'] == '::1' || $_SERVER['REMOTE_ADDR'] == '127.0.0.1';
  }

}

